package gs.smolban.db

import cats.data.EitherT
import gs.smolban.model.Tag

trait TagDb[F[_]]:
  def createTag(tag: Tag.Value): EitherT[F, DbError, Tag]
  def readTag(id: Tag.Id): F[Option[Tag]]
  def deleteTag(id: Tag.Id): F[Boolean]
