package gs.smolban.db.doobie

import cats.data.EitherT
import cats.effect.Async
import doobie.*
import doobie.implicits.*
import gs.smolban.db.DbError
import gs.smolban.db.TicketDb
import gs.smolban.db.doobie.DoobieTypes.*
import gs.smolban.model.CreatedAt
import gs.smolban.model.CreatedBy
import gs.smolban.model.Group
import gs.smolban.model.Ticket
import gs.smolban.model.users.User

final class DoobieTicketDb[F[_]: Async](
  val xa: Transactor[F]
) extends TicketDb[F]:
  import DoobieTicketDb.Sql

  /** @inheritdoc
    */
  override def createTicket(ticket: Ticket): EitherT[F, DbError, Ticket] = ???

  /** @inheritdoc
    */
  override def readTicket(ref: Ticket.Reference): F[Option[Ticket]] =
    ???
    // Sql.readTicket(ref.id, ref.group).option.transact(xa)
    // for compose multiple reads

  /** @inheritdoc
    */
  override def updateTicket(
    ref: Ticket.Reference,
    newValue: Ticket
  ): F[Option[Ticket]] = ???

  /** @inheritdoc
    */
  override def deleteTicket(ref: Ticket.Reference): F[Boolean] = ???

object DoobieTicketDb:

  private object Sql:

    case class TicketContents(
      createdAt: CreatedAt,
      createdBy: CreatedBy,
      title: String,
      description: String,
      status: Ticket.Status,
      assignee: Option[User.Id]
    )

    // TODO: figure out how to read tags
    // also storing them
    // make tagdb and such...

    def readTicket(
      ticketId: Ticket.Id,
      groupId: Group.Id
    ): Query0[TicketContents] = sql"""
      SELECT
        created_at, created_by, title, description, status, assignee
      FROM tickets
      WHERE
        ticket_id = $ticketId AND group_id = $groupId
      """.query[TicketContents]

  end Sql

end DoobieTicketDb
